=begin
#-----------------------------------------------------------------------
Copyright 2009-2014 TIG: Permission to use, copy, modify, and distribute 
this software for any purpose and without fee is hereby granted, 
provided this notice appears in any copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------
Adds faces that are 'missing' from selected edges.
It's not foolproof...
Be aware that it might make internal faces you don't expect...
You can call it from other scripts by making a selection-set then...
  TIG.addfaces()
To run manually make a selection and type 'TIG.addfaces' in the ruby console
(without the surrounding '')
It has a Plugins menu entry and a context-menu if an edge is selected.
#-----------------------------------------------------------------------
Version:	
1.0	20090327 First issue.
2.0 20131202 Future-proofed and Plugins/context-menu item added.
2.1 20140607 Progress-indicator added.
#-----------------------------------------------------------------------
=end
require 'sketchup.rb'
module TIG
###
	def self.addfaces()
		model=Sketchup.active_model
		model.start_operation("AddFaces")
			es=model.selection.grep(Sketchup::Edge)
			tot=es.length
			es.each_with_index{|e, i|
				Sketchup.status_text="TIG.addfaces: Edge #{i+1}/#{tot}"
				e.find_faces
			}
		model.commit_operation
		Sketchup.status_text=""
	end#def
	###
	unless file_loaded?(__FILE__)
		UI.menu("Plugins").add_item("Add Faces [to Selected Edges]"){self.addfaces()}
		### #Optional Context Menu
		UI.add_context_menu_handler{|menu|### only shows if edge selected
			if Sketchup.active_model.selection.grep(Sketchup::Edge)[0]
				menu.add_item("Add Faces [to Selected Edges]"){self.addfaces()}
			end#if
		}
	end
	file_loaded(__FILE__)
###
end#module TIG
### #EOF
